Skip to main content
`Ctrl`+`K`

# MatDenseCUDARestoreArrayRead

Restore read-only access to the CUDA buffer inside a `MATDENSECUDA` matrix previously obtained with a call to `MatDenseCUDAGetArrayRead()`.

## Synopsis

    PetscErrorCode MatDenseCUDARestoreArrayRead(Mat A, const PetscScalar **a)

Not Collective

## Input Parameters

- A - the matrix

- a - the GPU array in column major order

## Note

Data can be copied to the GPU due to operations done on the CPU. If you need write only access, use `MatDenseCUDAGetArrayWrite()`.

## See Also

`MATDENSECUDA`, `MatDenseCUDAGetArray()`, `MatDenseCUDARestoreArray()`, `MatDenseCUDARestoreArrayWrite()`, `MatDenseCUDAGetArrayWrite()`, `MatDenseCUDAGetArrayRead()`

## Level

developer

## Location

src/mat/impls/dense/mpi/cupm/cuda/matmpidensecuda.cu

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages